javax.lang.model.type

## Interface TypeVisitor<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Known Implementing Classes:
    AbstractTypeVisitor6, SimpleTypeVisitor6, TypeKindVisitor6

      public interface TypeVisitor<R,P>

  A visitor of types, in the style of the visitor design pattern. Classes implementing this interface are used to operate on a type when the kind of type is unknown at compile time. When a visitor is passed to a type's `accept` method, the `visitXYZ` method most applicable to that type is invoked.

  Classes implementing this interface may or may not throw a `NullPointerException` if the additional parameter `p` is `null`; see documentation of the implementing class for details.

  WARNING: It is possible that methods will be added to this interface to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, visitor classes directly implementing this interface may be source incompatible with future versions of the platform. To avoid this source incompatibility, visitor implementations are encouraged to instead extend the appropriate abstract visitor class that implements this interface. However, an API should generally use this visitor interface as the type for parameters, return type, etc. rather than one of the abstract classes.

  Since:
    1.6

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `R` | `visit(TypeMirror t)` A convenience method equivalent to `v.visit(t, null)`.
    `R` | `visit(TypeMirror t, P p)` Visits a type.
    `R` | `visitArray(ArrayType t, P p)` Visits an array type.
    `R` | `visitDeclared(DeclaredType t, P p)` Visits a declared type.
    `R` | `visitError(ErrorType t, P p)` Visits an error type.
    `R` | `visitExecutable(ExecutableType t, P p)` Visits an executable type.
    `R` | `visitNoType(NoType t, P p)` Visits a `NoType` instance.
    `R` | `visitNull(NullType t, P p)` Visits the null type.
    `R` | `visitPrimitive(PrimitiveType t, P p)` Visits a primitive type.
    `R` | `visitTypeVariable(TypeVariable t, P p)` Visits a type variable.
    `R` | `visitUnknown(TypeMirror t, P p)` Visits an unknown kind of type.
    `R` | `visitWildcard(WildcardType t, P p)` Visits a wildcard type.

- - ### Method Detail

    - #### visit

          R visit(TypeMirror t,
                P p)

      Visits a type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visit

          R visit(TypeMirror t)

      A convenience method equivalent to `v.visit(t, null)`.
      Parameters:
        `t` - the element to visit
      Returns:
        a visitor-specified result

    - #### visitPrimitive

          R visitPrimitive(PrimitiveType t,
                         P p)

      Visits a primitive type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitNull

          R visitNull(NullType t,
                    P p)

      Visits the null type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitArray

          R visitArray(ArrayType t,
                     P p)

      Visits an array type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitDeclared

          R visitDeclared(DeclaredType t,
                        P p)

      Visits a declared type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitError

          R visitError(ErrorType t,
                     P p)

      Visits an error type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitTypeVariable

          R visitTypeVariable(TypeVariable t,
                            P p)

      Visits a type variable.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitWildcard

          R visitWildcard(WildcardType t,
                        P p)

      Visits a wildcard type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitExecutable

          R visitExecutable(ExecutableType t,
                          P p)

      Visits an executable type.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitNoType

          R visitNoType(NoType t,
                      P p)

      Visits a `NoType` instance.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitUnknown

          R visitUnknown(TypeMirror t,
                       P p)

      Visits an unknown kind of type. This can occur if the language evolves and new kinds of types are added to the `TypeMirror` hierarchy.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result
      Throws:
        `UnknownTypeException` - a visitor implementation may optionally throw this exception

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.